---
layout:	post
title:	Micro v2.0.0 release is out!
date:	2020-01-30 09:00:00
---
<br>
We're happy to announce the release of Micro and Go Micro v2! This release is a major milestone for 
us as we adopt gRPC and embedded NATS by default.

See the releases here

- [https://github.com/micro/micro/releases/tag/v2.0.0](https://github.com/micro/micro/releases/tag/v2.0.0)
- [https://github.com/micro/go-micro/releases/tag/v2.0.0](https://github.com/micro/go-micro/releases/tag/v2.0.0)

## Evolution

[**Micro**](https://m3o.com) is 5 years in the making now and through that time the tools in our industry have drastically changed. 
We're moving towards cloud-native being the defacto standard for how we build software.

Our vision from day 1 was always around [Microservices](https://m3o.com/blog/2016/03/17/introduction.html) and the 
power of what it unlocks insides orgs that buy into this form of development. We also fundamentally believed 
in [RPC](https://m3o.com/blog/2016/03/20/micro.html) and the direction of these patterns based on our 
existing experiences at Google and Hailo.

Since then though we've seen the emergence of gRPC, the dominance of kubernetes and many more systems including 
the service mesh wave. Micro has stood through this test of time and actually thrived as it remained **developer 
first focused**.

To us all these tools are merely implementation details. What really matters is the abstractions and opinions 
provided to the developer and this is why developers continue to adopt Micro in waves.

We are never the early adopters of these new technologies but when a standard emerges we're fully onboard with 
committing to a certain direction. In this case we've picked gRPC for synchronous communication and NATS for 
async messaging.

## Road Ahead

Micro started as a solo effort in 2015 as many of you have probably heard numerous times before but we're now slowly growing a 
group of maintainers and a full time team to build out the next generation of tools and a platform to go beyond 
open source.

Micro wil be the defacto standard for microservices development in the Cloud and beyond as we look to build a serverless 
platform so developers can focus on what really matters and stop thinking about the underlying infrastructure.

Join our #platform channel on [Slack](https://m3o.com/community) to be the first to try it out.

<center>...</center>
<br>
Micro is the simplest way to build microservices. If you're thinking about microservice development we want to help enable you on that journey. 
To learn more check out the [website](https://m3o.com), follow us on [twitter](https://twitter.com/m3ocloud) or 
join the [slack](https://slack.m3o.com) community.

<h6><a href="https://github.com/micro/micro"><i class="fab fa-github fa-2x"></i> Micro</a></h6>
